<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close :close-on-click-modal="false" @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px" label-position="left">
			<el-form-item label="上级部门" prop="parent_id">
				<el-cascader v-model="form.parent_id" :options="groups" :props="groupsProps" :show-all-levels="false" clearable style="width: 100%;"></el-cascader>
			</el-form-item>
			<el-form-item label="部门名称" prop="title">
				<el-input v-model="form.title" clearable></el-input>
			</el-form-item>
			<el-form-item label="部门别名" prop="name">
				<el-input v-model="form.name" clearable></el-input>
			</el-form-item>
			<el-form-item label="排序" prop="sort">
				<el-input-number v-model="form.sort" controls-position="right" :min="1" style="width: 100%;"></el-input-number>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSaveing" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增',
				edit: '编辑',
				show: '查看'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: {id:"",title: "",name: "",sort: 1,parent_id: ""},
			//验证规则
			rules: {
				sort: [{required: true, message: '请输入排序', trigger: 'change'}],
				title: [{required: true, message: '请输入角色名称'}],
				name: [{required: true, message: '请输入角色别名'}]
			},
			//所需数据选项
			groups: [],
			groupsProps: {
				value: "id",
				label: "title",
				emitPath: false,
				checkStrictly: true
			}
		}
	},
	mounted() {
		this.getGroup()
	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//加载树数据
		async getGroup(){
			var res = await this.$API.auth.department.list.get({is_tree: 1});
			this.groups = res.data;
		},
		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSaveing = true;
					this.form.parent_id = this.form.parent_id ? this.form.parent_id : 0;
					var res = {}
					if(this.mode == 'add'){
						res = await this.$API.auth.department.add.post(this.form);
					}else{
						res = await this.$API.auth.department.edit.post(this.form);
					}
					this.isSaveing = false;
					if(res.code == 1){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}else{
						this.$message.error(res.message)
					}
				}
			})
		},
		//表单注入数据
		setData(data){
			this.form.id = data.id
			this.form.title = data.title
			this.form.name = data.name
			this.form.sort = data.sort
			this.form.parent_id = data.parent_id
		}
	}
}
</script>
